## hhsuite 3.0~beta3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(hhsuite CXX)

SET(HAVE_SSSE3 0 CACHE BOOL "Have SSSE3")
SET(HAVE_AVX2 0 CACHE BOOL "Have AVX2")

#set(CMAKE_BUILD_TYPE Release)

# find compiler
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  message("-- Compiler is clang(++)")
  set(CMAKE_COMPILER_IS_CLANG 1)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  message("-- Compiler is GNU ")
  set(CMAKE_COMPILER_IS_GNUCXX 1)
  set(CMAKE_COMPILER_IS_GNUCCC 1)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
  message("-- Compiler is ICC ")
  set(CMAKE_COMPILER_IS_ICC 1)
endif()


message("-- Processor is ${CMAKE_SYSTEM_PROCESSOR}")

if(CMAKE_SYSTEM_PROCESSOR MATCHES "amd64.*|x86_64.*|AMD64.*")
  set(X86_64 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "i686.*|i386.*|x86.*|amd64.*|AMD64.*")
  set(X86 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*)")
  set(ARM 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*)")
  set(AARCH64 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
  set(PPC64 1)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "PPC*|ppc*|powerpc*")
  set(PPC 1)
endif()



set (HHSUITE_VERSION_MAJOR 3)
set (HHSUITE_VERSION_MINOR 0)
set (HHSUITE_VERSION_PATCH 0)
set (HHSUITE_DATE "15-03-2015")

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

INSTALL(FILES
  hhsuite-userguide.pdf
  LICENSE
  README
  PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
  DESTINATION ./
)

include_directories(src)
include_directories(lib/ffindex/src)

add_subdirectory(lib/ffindex)
add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(scripts)
add_subdirectory(test)
#add_subdirectory(doc)


SET (CPACK_GENERATOR "DEB;TGZ;ZIP;RPM")
SET (CPACK_DEBIAN_PACKAGE_MAINTAINER "Markus Meier")

set(CPACK_SOURCE_IGNORE_FILES
  ".synctex.gz$"
  ".toc$"
  ".blg$"
  ".bbl$"
  ".aux$"
  ".log$"
  ".dvi$"
  ".out.ps$"
  "/rpm/"
  "^${PROJECT_SOURCE_DIR}/build/"
  "^${PROJECT_SOURCE_DIR}/.git/"
  "^${PROJECT_SOURCE_DIR}/.gitignore"
  "^${PROJECT_SOURCE_DIR}/.gitattributes"
  "^${PROJECT_SOURCE_DIR}/.gitmodules"
  "^${PROJECT_SOURCE_DIR}/.pydevproject"
  "^${PROJECT_SOURCE_DIR}/.project"
  "^${PROJECT_SOURCE_DIR}/.cproject"
  "^${PROJECT_SOURCE_DIR}/lib/ffindex/.git"
  "^${PROJECT_SOURCE_DIR}/lib/ffindex/.git"
  "^${PROJECT_SOURCE_DIR}/.autotools"
  "^${PROJECT_SOURCE_DIR}/README.md"
)

set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set (CPACK_PACKAGE_VERSION_MAJOR "${HHSUITE_VERSION_MAJOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${HHSUITE_VERSION_MINOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${HHSUITE_VERSION_PATCH}")
INCLUDE(CPack)

enable_testing()

=== scripts/CMakeLists.txt ===

INSTALL(PROGRAMS
	Align.pm  
	HHPaths.pm  
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
	DESTINATION scripts
)


INSTALL(PROGRAMS 
	addss.pl  
	create_profile_from_hhm.pl	
	hhmakemodel.pl	
	hhsuitedb.py  
	mergeali.pl
	multithread.pl  
	pdbfilter.pl  
	renumberpdb.pl
	create_profile_from_hmmer.pl	
	pdb2fasta.pl    
	reformat.pl   
	splitfasta.pl
	check_a3m.py	  
	ffindex.py
	a3m.py
	get_a3m_size.py
	pdbfilter.py
	cif2fasta.py
	hhmakemodel.py
  hh_reader.py
	DESTINATION scripts
)

=== src/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")

#Sanitizers
if(${HAVE_SANITIZER})
	include(FindUBSan)
	include(FindASan)
	include(FindMSan)
	include(FindTSan)
endif()


if(X86 OR X86_64)

#SSE
if(${HAVE_AVX2})
    ADD_DEFINITIONS("-DAVX2")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2 -Wa,-q")
elseif(${HAVE_SSSE3})
    ADD_DEFINITIONS("-DSSE")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mssse3")
else()
    include(CheckSSEFeatures)
    ADD_DEFINITIONS(${CXX_DFLAGS})
    if(${HAVE_AVX2_EXTENSIONS})
        ADD_DEFINITIONS("-DAVX2")
    elseif(${HAVE_SSSE3_EXTENSIONS})
        ADD_DEFINITIONS("-DSSE")
    else()
        message( FATAL_ERROR "SSSE3 is needed to run compile! CMake will exit." )
    endif(${HAVE_AVX2_EXTENSIONS})
endif()

else() #

message("!! NOT X86 OR X86_64 !!")

endif() # NOT X86 OR X86_64



find_package(OpenMP)
if (OPENMP_FOUND)
	message("-- Found OpenMP")
	add_definitions(-DOPENMP)
	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")

add_subdirectory(cs)
include_directories(cs)
include_directories("${PROJECT_BINARY_DIR}")

set(HH_SOURCE
	${HH_SOURCE}
	${CMAKE_CURRENT_SOURCE_DIR}/hhblits.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhblits.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhdecl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhdecl.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhit.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhit-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhit.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhmatrices.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhmatrices.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhsearch.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhsearch.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhalign.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhalign.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhitlist.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhitlist-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhitlist.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoder.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoder.cpp 
	${CMAKE_CURRENT_SOURCE_DIR}/hhutil.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhutil-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhutil.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/util.h
	${CMAKE_CURRENT_SOURCE_DIR}/util.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhalignment.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhalignment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhforwardalgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmm.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoderrunner.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriordecoderrunner.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbialgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhfullalignment.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhfullalignment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmmsimd.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhmmsimd.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriormatrix.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhposteriormatrix.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbi.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbi.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhbacktracemac.cpp 
	${CMAKE_CURRENT_SOURCE_DIR}/hhmacalgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhprefilter.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhprefilter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbimatrix.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbimatrix-inl.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbimatrix.cpp 
	${CMAKE_CURRENT_SOURCE_DIR}/hhbackwardalgorithm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhdatabase.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhdatabase.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhhalfalignment.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhhalfalignment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbirunner.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhviterbirunner.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hhfunc.h
	${CMAKE_CURRENT_SOURCE_DIR}/hhfunc.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/simd.h
)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${CMAKE_CURRENT_SOURCE_DIR}/hhsuite_config.h.in"
  "${PROJECT_BINARY_DIR}/hhsuite_config.h"
)

add_library(HH_OBJECTS OBJECT ${HH_SOURCE})

add_library(hhviterbialgorithm_with_celloff OBJECT hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_with_celloff PROPERTY COMPILE_FLAGS "-DVITERBI_CELLOFF=1")

add_library(hhviterbialgorithm_with_celloff_and_ss OBJECT hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_with_celloff_and_ss PROPERTY COMPILE_FLAGS "-DVITERBI_CELLOFF=1 -DVITERBI_SS_SCORE=1")

add_library(hhviterbialgorithm_and_ss OBJECT hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_and_ss PROPERTY COMPILE_FLAGS "-DVITERBI_SS_SCORE=1")


add_library(CS_OBJECTS OBJECT ${CS_SOURCE})

# add the executable
add_executable(hhblits 
    hhblits_app.cpp	$<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
    $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
    $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
    $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhblits ffindex)

if (OPENMP_FOUND)
    add_executable(hhblits_omp
        hhblits_omp.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
        $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
        $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
        $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
    )
    target_link_libraries (hhblits_omp ffindex)

    INSTALL(PROGRAMS 
        ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits_omp
        DESTINATION bin
    )
endif()

add_executable(hhmake
  hhmake.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhmake ffindex)

add_executable(hhfilter
  hhfilter.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhfilter ffindex)

add_executable(hhsearch
  hhsearch_app.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhsearch ffindex)

add_executable(hhalign
  hhalign_app.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhalign ffindex)

add_executable(hhconsensus
  hhconsensus.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
  $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
  $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
)
target_link_libraries (hhconsensus ffindex)


add_library(A3M_COMPRESS_OBJECT OBJECT a3m_compress.cpp)

add_executable(a3m_extract
	a3m_extract.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_extract ffindex)

add_executable(a3m_reduce
  a3m_reduce.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_reduce ffindex)

add_executable(a3m_database_reduce
  a3m_database_reduce.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_database_reduce ffindex)

add_executable(a3m_database_extract
  a3m_database_extract.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_database_extract ffindex)

add_executable(a3m_database_filter
  a3m_database_filter.cpp $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (a3m_database_filter ffindex)

add_executable(cstranslate
  cs/cstranslate_app.cc
        $<TARGET_OBJECTS:CS_OBJECTS>
        $<TARGET_OBJECTS:HH_OBJECTS>
        $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
        $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
        $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
        $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
)
target_link_libraries (cstranslate ffindex)

find_package(MPI QUIET)

if(MPI_CXX_FOUND)
    include_directories(${MPI_CXX_INCLUDE_PATH})

    #hhblits_mpi
    add_executable(hhblits_mpi
	         hhblits_mpi.cpp $<TARGET_OBJECTS:CS_OBJECTS> $<TARGET_OBJECTS:HH_OBJECTS>
	         $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
	         $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
	         $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
	       )
    target_link_libraries(hhblits_mpi ffindex mpq)
    target_link_libraries(hhblits_mpi ${MPI_CXX_LIBRARIES})
    set_target_properties(hhblits_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS}")
    set_target_properties(hhblits_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits_mpi DESTINATION bin)

    #cstranslate_mpi
    add_executable(cstranslate_mpi
            cs/cstranslate_mpi_app.cc
            $<TARGET_OBJECTS:CS_OBJECTS>
            $<TARGET_OBJECTS:HH_OBJECTS>
            $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff>
            $<TARGET_OBJECTS:hhviterbialgorithm_and_ss>
            $<TARGET_OBJECTS:hhviterbialgorithm_with_celloff_and_ss>
            $<TARGET_OBJECTS:A3M_COMPRESS_OBJECT>
            )
    target_link_libraries(cstranslate_mpi ffindex mpq)
    target_link_libraries(cstranslate_mpi ${MPI_CXX_LIBRARIES})
    set_target_properties(cstranslate_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS}")
    set_target_properties(cstranslate_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cstranslate_mpi DESTINATION bin)
endif()

INSTALL(PROGRAMS 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhblits 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhmake 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhfilter 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhsearch 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhalign 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/hhconsensus 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_extract
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_database_reduce
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_database_extract
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/a3m_database_filter 
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cstranslate
	DESTINATION bin
)

=== debian/changelog ===
hhsuite (3.0~beta3+dfsg-3) unstable; urgency=high

  * Team upload

  [ Andreas Tille ]
  * Build against ffindex (>= 0.9.9.8)

  [ Michael R. Crusoe ]
  * Don't build with -march=native

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 15 Feb 2019 10:06:44 -0800

hhsuite (3.0~beta3+dfsg-2) unstable; urgency=medium

  * Install context_data.crf (Thanks for the patch to Andrius Merkys
    <andrius.merkys@gmail.com>)
    Closes: #918765
  * Add autopkgtest reproducing the issue of bug #918765
  * debhelper 11
  * Standards-Version: 4.3.0
  * Secure URI in copyright format
  * Remove trailing whitespace in debian/copyright
  * Do not parse d/changelog
  * Add versioned (Build-)Depends: ffindex
    (>= 0.9.9.7.soedinglab+git20171201.74550c8)
  * Adapt doc-base file to debhelper 11 location

 -- Andreas Tille <tille@debian.org>  Wed, 09 Jan 2019 17:36:27 +0100

hhsuite (3.0~beta3+dfsg-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * New upstream version.
  * debian/upstream/metadata:
    - yamllint cleanliness
    - Added references to registries
  * d/control
    - compliance with policy 4.2
    - adapted Vcs URLs to salsa.d.o
  * Caveat: Does not compile with openmpi libraries discovered.
    See README.source.

  [ Andreas Tille ]
  * Fix Vcs-Browser
  * Do not parse d/changelog to obtain version

 -- Andreas Tille <tille@debian.org>  Tue, 21 Aug 2018 21:09:09 +0200

=== debian/control ===
Source: hhsuite
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Laszlo Kajan <lkajan@debian.org>,
           Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               libffindex0-dev (>= 0.9.9.8),
               cmake,
               texlive-latex-base,
               texlive-latex-recommended,
               imagemagick,
               help2man
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/hhsuite
Vcs-Git: https://salsa.debian.org/med-team/hhsuite.git
Homepage: https://toolkit.tuebingen.mpg.de/

Package: hhsuite
Architecture: amd64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ffindex (>= 0.9.9.8),
         hhsuite-data (= ${source:Version}),
         python
Breaks: hhsuite-data (<= 2.0.16-1)
Description: sensitive protein sequence searching based on HMM-HMM alignment
 HH-suite is an open-source software package for sensitive protein sequence
 searching based on the pairwise alignment of hidden Markov models (HMMs).
 .
 This package contains HHsearch and HHblits among other programs and utilities.
 .
 HHsearch takes as input a multiple sequence alignment (MSA) or profile HMM
 and searches a database of HMMs (e.g. PDB, Pfam, or InterPro) for homologous
 proteins. HHsearch is often used for protein structure prediction to detect
 homologous templates and to build highly accurate query-template pairwise
 alignments for homology modeling.
 .
 HHblits can build high-quality MSAs starting from single sequences or from
 MSAs. It transforms these into a query HMM and, using an iterative search
 strategy, adds significantly similar sequences from the previous search to
 the updated query HMM for the next search iteration. Compared to PSI-BLAST,
 HHblits is faster, up to twice as sensitive and produces more accurate
 alignments.

Package: hhsuite-doc
Architecture: all
Section: doc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: hhsuite
Breaks: hhsuite (<= 2.0.16-1)
Replaces: hhsuite (<= 2.0.16-1)
Description: documentation for HHsuite for HMM-HMM comparisons
 HH-suite is an open-source software package for sensitive protein sequence
 searching based on the pairwise alignment of hidden Markov models (HMMs).
 .
 This package provides a PDF with the user guide for HH-suite.

Package: hhsuite-data
Architecture: all
Depends: ${misc:Depends}
Description: sensitive protein sequence searching based on HMM-HMM alignment (data)
 HH-suite is an open-source software package for sensitive protein sequence
 searching based on the pairwise alignment of hidden Markov models (HMMs).
 .
 This package contains architecture independent scripts and data files.

## hhsuite 3.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(hhsuite C CXX)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(HAVE_SSE2 0 CACHE BOOL "Have SSE2")
set(HAVE_AVX2 0 CACHE BOOL "Have AVX2")
set(ENABLE_SANITIZERS 0 CACHE BOOL "Enable Sanitizers")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif (NOT CMAKE_BUILD_TYPE)

if (${ENABLE_SANITIZERS})
    include(FindUBSan)
    include(FindASan)
    include(FindMSan)
    include(FindTSan)
endif ()

set(HHSUITE_VERSION_MAJOR 3)
set(HHSUITE_VERSION_MINOR 1)
set(HHSUITE_VERSION_PATCH 0)

include_directories(${CMAKE_BINARY_DIR}/generated)
include_directories(${PROJECT_BINARY_DIR}/generated)
include_directories(src)
include_directories(lib/ffindex/src)

add_subdirectory(lib/ffindex)
add_subdirectory(data)
add_subdirectory(src)
add_subdirectory(scripts)

set(CPACK_GENERATOR "DEB;TGZ;ZIP;RPM")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Markus Meier")

set(CPACK_SOURCE_IGNORE_FILES
        "/rpm/"
        "^${PROJECT_SOURCE_DIR}/build/"
        "^${PROJECT_SOURCE_DIR}/.git/"
        "^${PROJECT_SOURCE_DIR}/.gitignore"
        "^${PROJECT_SOURCE_DIR}/.gitattributes"
        "^${PROJECT_SOURCE_DIR}/lib/ffindex/.git"
        )

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_VERSION_MAJOR "${HHSUITE_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${HHSUITE_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${HHSUITE_VERSION_PATCH}")
include(CPack)

=== data/CMakeLists.txt ===
INSTALL(FILES
        context_data.crf
        context_data.lib
        cs219.lib
        do_not_delete
        do_not_delete.phr
        do_not_delete.pin
        do_not_delete.psq
        PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
        DESTINATION data
        )

include(ResourceCompiler)
set(COMPILED_RESOURCES
        context_data.crf
        context_data.lib
        cs219.lib
        )

set(GENERATED_OUTPUT_HEADERS "")
FOREACH(INPUT_FILE ${COMPILED_RESOURCES})
    compile_resource(${INPUT_FILE} OUTPUT_FILE)
    list(APPEND GENERATED_OUTPUT_HEADERS "${OUTPUT_FILE}")
ENDFOREACH()

add_custom_target(generated ALL DEPENDS ${GENERATED_OUTPUT_HEADERS})

=== scripts/CMakeLists.txt ===
INSTALL(PROGRAMS
        a3m.py
        addss.pl
        Align.pm
        check_a3m.py
        cif2fasta.py
        create_profile_from_hhm.pl
        create_profile_from_hmmer.pl
        ffindex.py
        get_a3m_size.py
        hh_reader.py
        hhmakemodel.pl
        hhmakemodel.py
        HHPaths.pm
        hhsuitedb.py
        mergeali.pl
        multithread.pl
        pdb2fasta.pl
        pdbfilter.pl
        pdbfilter.py
        reformat.pl
        renumberpdb.pl
        splitfasta.pl
        DESTINATION scripts
        )

=== src/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
set(CHECK_MPI 1 CACHE BOOL "Check MPI availability")

if (${HAVE_AVX2})
    ADD_DEFINITIONS("-DAVX2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2 -Wa,-q")
elseif (${HAVE_SSE2})
    ADD_DEFINITIONS("-DSSE")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse -msse2")
else ()
    include(CheckSSEFeatures)
    ADD_DEFINITIONS(${CXX_DFLAGS})
    if (${HAVE_AVX2_EXTENSIONS})
        ADD_DEFINITIONS("-DAVX2")
    elseif (${HAVE_SSE2_EXTENSIONS})
        ADD_DEFINITIONS("-DSSE")
    else ()
        message(FATAL_ERROR "At least SSE2 instruction set support is required! CMake will exit.")
    endif (${HAVE_AVX2_EXTENSIONS})
endif ()

find_package(OpenMP)
if (OPENMP_FOUND)
    message("-- Found OpenMP")
    add_definitions(-DOPENMP)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif ()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")

# pass some of the CMake settings to the source code
configure_file("hhsuite_config.h.in" "hhsuite_config.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(cs)
include_directories(cs)

set(HH_SOURCE
        hash.h
        hhblits.h
        hhblits.cpp
        hhdecl.h
        hhdecl.cpp
        hhhit.h
        hhhit-inl.h
        hhhit.cpp
        hhmatrices.h
        hhmatrices.cpp
        hhsearch.h
        hhsearch.cpp
        hhalign.h
        hhalign.cpp
        hhhitlist.h
        hhhitlist-inl.h
        hhhitlist.cpp
        hhposteriordecoder.h
        hhposteriordecoder.cpp
        hhutil.h
        hhutil-inl.h
        hhutil.cpp
        util.h
        util-inl.h
        util.cpp
        hhalignment.h
        hhalignment.cpp
        hhforwardalgorithm.cpp
        hhhmm.h
        hhhmm.cpp
        hhposteriordecoderrunner.h
        hhposteriordecoderrunner.cpp
        hhviterbialgorithm.cpp
        hhfullalignment.h
        hhfullalignment.cpp
        hhhmmsimd.h
        hhhmmsimd.cpp
        hhposteriormatrix.h
        hhposteriormatrix.cpp
        hhviterbi.h
        hhviterbi.cpp
        hhbacktracemac.cpp
        hhmacalgorithm.cpp
        hhprefilter.h
        hhprefilter.cpp
        hhviterbimatrix.h
        hhviterbimatrix-inl.h
        hhviterbimatrix.cpp
        hhbackwardalgorithm.cpp
        ffindexdatabase.h
        ffindexdatabase.cpp
        hhdatabase.h
        hhdatabase.cpp
        hhhalfalignment.h
        hhhalfalignment.cpp
        hhviterbirunner.h
        hhviterbirunner.cpp
        hhfunc.h
        hhfunc.cpp
        list.h
        log.h
        simd.h
        )

add_library(hhviterbialgorithm_with_celloff hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_with_celloff PROPERTY COMPILE_FLAGS "-DVITERBI_CELLOFF=1")

add_library(hhviterbialgorithm_with_celloff_and_ss hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_with_celloff_and_ss PROPERTY COMPILE_FLAGS "-DVITERBI_CELLOFF=1 -DVITERBI_SS_SCORE=1")

add_library(hhviterbialgorithm_and_ss hhviterbialgorithm.cpp)
set_property(TARGET hhviterbialgorithm_and_ss PROPERTY COMPILE_FLAGS "-DVITERBI_SS_SCORE=1")

add_library(HH_OBJECTS ${HH_SOURCE})
add_dependencies(HH_OBJECTS generated)
target_link_libraries(HH_OBJECTS
        ffindex
        CS_OBJECTS
        hhviterbialgorithm_with_celloff
        hhviterbialgorithm_and_ss
        hhviterbialgorithm_with_celloff_and_ss)
if (NOT HAVE_FMEMOPEN)
target_link_libraries(HH_OBJECTS ext)
endif()

add_executable(hhblits hhblits_app.cpp)
target_link_libraries(hhblits HH_OBJECTS)

add_executable(hhmake hhmake.cpp)
target_link_libraries(hhmake HH_OBJECTS)

add_executable(hhfilter hhfilter.cpp)
target_link_libraries(hhfilter HH_OBJECTS)

add_executable(hhsearch hhblits_app.cpp)
target_link_libraries(hhsearch HH_OBJECTS)
set_property(TARGET hhsearch PROPERTY COMPILE_FLAGS "-DHHSEARCH=1")

add_executable(hhalign hhblits_app.cpp)
target_link_libraries(hhalign HH_OBJECTS)
set_property(TARGET hhalign PROPERTY COMPILE_FLAGS "-DHHALIGN=1")

add_executable(hhconsensus hhconsensus.cpp)
target_link_libraries(hhconsensus HH_OBJECTS)

add_library(A3M_COMPRESS a3m_compress.cpp)

add_executable(a3m_extract a3m_extract.cpp)
target_link_libraries(a3m_extract ffindex A3M_COMPRESS)

add_executable(a3m_reduce a3m_reduce.cpp)
target_link_libraries(a3m_reduce ffindex A3M_COMPRESS)

add_executable(a3m_database_reduce a3m_database_reduce.cpp )
target_link_libraries(a3m_database_reduce ffindex A3M_COMPRESS)

add_executable(a3m_database_extract a3m_database_extract.cpp)
target_link_libraries(a3m_database_extract ffindex A3M_COMPRESS)

add_executable(a3m_database_filter a3m_database_filter.cpp)
target_link_libraries(a3m_database_filter ffindex A3M_COMPRESS)

add_executable(cstranslate cs/cstranslate_app.cc)
target_link_libraries(cstranslate HH_OBJECTS A3M_COMPRESS)

INSTALL(TARGETS
        hhblits
        hhmake
        hhfilter
        hhsearch
        hhalign
        hhconsensus
        a3m_extract
        a3m_reduce
        a3m_database_reduce
        a3m_database_extract
        a3m_database_filter
        cstranslate
        DESTINATION bin
        )

if (OPENMP_FOUND)
    add_executable(hhblits_omp hhblits_omp.cpp)
    target_link_libraries(hhblits_omp HH_OBJECTS)

    add_executable(hhsearch_omp hhblits_omp.cpp)
    target_link_libraries(hhsearch_omp HH_OBJECTS)
    set_property(TARGET hhsearch_omp PROPERTY COMPILE_FLAGS "-DHHSEARCH=1")

    add_executable(hhalign_omp hhblits_omp.cpp)
    target_link_libraries(hhalign_omp HH_OBJECTS)
    set_property(TARGET hhalign_omp PROPERTY COMPILE_FLAGS "-DHHALIGN=1")

    add_executable(hhblits_ca3m hhblits_ca3m.cpp)
    target_link_libraries (hhblits_ca3m HH_OBJECTS)

    INSTALL(TARGETS hhblits_omp hhsearch_omp hhalign_omp hhblits_ca3m DESTINATION bin)
endif ()

if (${CHECK_MPI})
find_package(MPI QUIET)
if (MPI_CXX_FOUND)
    include_directories(${MPI_CXX_INCLUDE_PATH})

    add_executable(hhblits_mpi hhblits_mpi.cpp)
    target_link_libraries(hhblits_mpi HH_OBJECTS mpq ${MPI_CXX_LIBRARIES})
    set_target_properties(hhblits_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS}")
    set_target_properties(hhblits_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    add_executable(hhsearch_mpi hhblits_mpi.cpp)
    target_link_libraries(hhsearch_mpi HH_OBJECTS mpq ${MPI_CXX_LIBRARIES})
    set_target_properties(hhsearch_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS} -DHHSEARCH=1")
    set_target_properties(hhsearch_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    add_executable(hhalign_mpi hhblits_mpi.cpp)
    target_link_libraries(hhalign_mpi HH_OBJECTS mpq ${MPI_CXX_LIBRARIES})
    set_target_properties(hhalign_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS} -DHHALIGN=1")
    set_target_properties(hhalign_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    add_executable(cstranslate_mpi cs/cstranslate_mpi_app.cc)
    target_link_libraries(cstranslate_mpi HH_OBJECTS A3M_COMPRESS mpq ${MPI_CXX_LIBRARIES})
    set_target_properties(cstranslate_mpi PROPERTIES COMPILE_FLAGS "${MPI_CXX_COMPILE_FLAGS}")
    set_target_properties(cstranslate_mpi PROPERTIES LINK_FLAGS "${MPI_CXX_LINK_FLAGS}")

    install(TARGETS hhblits_mpi hhsearch_mpi hhalign_mpi cstranslate_mpi DESTINATION bin)
endif ()
endif ()

=== debian/changelog ===
hhsuite (3.2.0-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:16:06 +0100

hhsuite (3.2.0-2) unstable; urgency=medium

  [ Santiago Vila ]
  * Fix FTBFS when built with dpkg-buildpackage -A
    Closes: #932912

  [ Andreas Tille ]
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Fix autopkgtest

 -- Andreas Tille <tille@debian.org>  Thu, 25 Jul 2019 03:06:04 +0200

hhsuite (3.2.0-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * New upstream release.
    "Added hhsearch_omp, hhsearch_mpi, hhalign_omp and haling_mpi binaries
     Removed non-GPLv3 compatible code
     ffindex_apply_mpi will not crash anymore on systems with low amount of
       virtual memory"
  * The non-GPLv3 code was in src/hhprefilter.cpp; now gone
  * Mark hhsuite-data as Multi-Arch: foreign
  * Drop hhsuite-doc: documentation moved by upstream to
    https://github.com/soedinglab/hh-suite/wiki
  * Removed '-march=native'

  [ Andrius Merkys ]
  * Revoking executable permission from Perl modules.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 23 Jul 2019 12:06:51 +0200

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,12 @@
            Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                libffindex0-dev (>= 0.9.9.8),
                cmake,
-               texlive-latex-base,
-               texlive-latex-recommended,
                imagemagick,
                help2man
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/hhsuite
 Vcs-Git: https://salsa.debian.org/med-team/hhsuite.git
 Homepage: https://toolkit.tuebingen.mpg.de/
@@ -21,10 +19,10 @@
 Architecture: amd64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
+         ${perl:Depends},
          ffindex (>= 0.9.9.8),
          hhsuite-data (= ${source:Version}),
-         python
-Breaks: hhsuite-data (<= 2.0.16-1)
+         python3
 Description: sensitive protein sequence searching based on HMM-HMM alignment
  HH-suite is an open-source software package for sensitive protein sequence
  searching based on the pairwise alignment of hidden Markov models (HMMs).
@@ -44,22 +42,9 @@
  HHblits is faster, up to twice as sensitive and produces more accurate
  alignments.
 
-Package: hhsuite-doc
-Architecture: all
-Section: doc
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Recommends: hhsuite
-Breaks: hhsuite (<= 2.0.16-1)
-Replaces: hhsuite (<= 2.0.16-1)
-Description: documentation for HHsuite for HMM-HMM comparisons
- HH-suite is an open-source software package for sensitive protein sequence
- searching based on the pairwise alignment of hidden Markov models (HMMs).
- .
- This package provides a PDF with the user guide for HH-suite.
-
 Package: hhsuite-data
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: sensitive protein sequence searching based on HMM-HMM alignment (data)
  HH-suite is an open-source software package for sensitive protein sequence

=== debian/watch ===
version=4

opts="uversionmangle=s/-beta\.(\d)/~beta$1/;s/-beta/~beta/,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
https://github.com/soedinglab/hh-suite/releases .*/archive/v(\d[-\d.beta]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## hhsuite 3.3.0%2Bds

=== lib/ffindex/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12 FATAL_ERROR)
SET(HAVE_MPI 1 CACHE BOOL "Have MPI")

project(ffindex C)
include_directories(src)
include_directories(src/ext)
add_subdirectory(src)

=== src/cs/CMakeLists.txt ===
set(CS_SOURCE
	aa.cc
	as.cc
	assert_helpers.cc
	blosum_matrix.cc
	getopt_pp.cc
	log.cc
	application.cc
)

add_library(CS_OBJECTS ${CS_SOURCE})

=== debian/changelog ===
hhsuite (3.3.0+ds-9) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1112991
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 17:36:29 +0200

hhsuite (3.3.0+ds-8) unstable; urgency=medium

  * Team upload.
  * gcc-13.patch: new: fix ftbfs with gcc 13. (Closes: #1037689)
  * d/control: declare compliance to standards version 4.6.2.

 -- Étienne Mollier <emollier@debian.org>  Sun, 13 Aug 2023 10:47:11 +0200

hhsuite (3.3.0+ds-7) unstable; urgency=medium

  * Fix watchfile.
  * Bump Standards-Version.
  * Update date in d/copyright.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 25 Oct 2022 15:17:24 +0200

hhsuite (3.3.0+ds-6) unstable; urgency=medium

  * Adjust patch to not overwrite example files in tests.
    This caused a modified file containing the build time to be packaged,
    leaving the package unreproducible (and is likely not intended here)

 -- Sascha Steinbiss <satta@debian.org>  Mon, 22 Nov 2021 22:27:31 +0100

hhsuite (3.3.0+ds-5) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Remove trailing whitespace in debian/copyright (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 14:36:58 +0200

hhsuite (3.3.0+ds-4) unstable; urgency=medium

  * Team upload.
  * Fix tests on non-x86.
  * Include Built-Using: ${simde:Built-Using} to satisfy GPL requirements

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 02 Sep 2020 15:39:19 +0200

hhsuite (3.3.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Drop unused add_Makefile_in_data.patch
  * Apply patch from upstream to enable full testing without MPI
  * Ship the ffindex binaries from the hhsuite fork and Conflict with the
    ffindex package.
  * Replace disable-AVX-SSE.patch with NATIVE_ARCH=0
  * Build-depend on libsimde-dev 0.6.0-2 to get i386 related patches

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 02 Sep 2020 13:18:00 +0200

hhsuite (3.3.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix non-x86 builds

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 01 Sep 2020 11:37:48 +0200

hhsuite (3.3.0+ds-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Refresh patches
  * Include the a3m_* utilities
  * Exclude lib/simde and use libsimde-dev instead
  * Add missing GPL-2 text to debian/copyright
  * On i386 & amd64: build one binary for each SIMD level; add dispatching
    script
  * Upstream has hard forked ffindex, so use their copy
  * Removed two old, unused patches

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 31 Aug 2020 15:18:43 +0200

hhsuite (3.2.0-3) unstable; urgency=medium

  [ Steffen Möller ]
  * Added ref to conda

  [ Frédéric Bonnard ]
  * Enable ppc64el

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

 -- Andreas Tille <tille@debian.org>  Tue, 17 Mar 2020 09:50:48 +0100

## hhsuite 3.3.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,15 +2,26 @@
 project(hhsuite C CXX)
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
-set(HAVE_SSE2 0 CACHE BOOL "Have SSE2")
-set(HAVE_AVX2 0 CACHE BOOL "Have AVX2")
 set(ENABLE_SANITIZERS 0 CACHE BOOL "Enable Sanitizers")
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release)
-endif (NOT CMAKE_BUILD_TYPE)
+endif ()
 
-if (${ENABLE_SANITIZERS})
+if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    message("-- Compiler is clang(++)")
+    set(CMAKE_COMPILER_IS_CLANG 1)
+elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    message("-- Compiler is GNU ")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8.0")
+        message(FATAL_ERROR "Insufficient gcc version")
+    endif ()
+elseif (CMAKE_CXX_COMPILER_ID MATCHES "Intel")
+    message("-- Compiler is icc(++)")
+    set(CMAKE_COMPILER_IS_ICC 1)
+endif ()
+
+if (ENABLE_SANITIZERS)
     include(FindUBSan)
     include(FindASan)
     include(FindMSan)
@@ -18,13 +29,15 @@
 endif ()
 
 set(HHSUITE_VERSION_MAJOR 3)
-set(HHSUITE_VERSION_MINOR 1)
+set(HHSUITE_VERSION_MINOR 3)
 set(HHSUITE_VERSION_PATCH 0)
 
 include_directories(${CMAKE_BINARY_DIR}/generated)
 include_directories(${PROJECT_BINARY_DIR}/generated)
 include_directories(src)
 include_directories(lib/ffindex/src)
+include_directories(lib/simde)
+include_directories(lib/simd)
 
 add_subdirectory(lib/ffindex)
 add_subdirectory(data)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,22 +1,83 @@
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 set(CHECK_MPI 1 CACHE BOOL "Check MPI availability")
-
-if (${HAVE_AVX2})
-    ADD_DEFINITIONS("-DAVX2")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2 -Wa,-q")
-elseif (${HAVE_SSE2})
-    ADD_DEFINITIONS("-DSSE")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse -msse2")
+set(HAVE_AVX2 0 CACHE BOOL "Have CPU with AVX2")
+set(HAVE_SSE4_1 0 CACHE BOOL "Have CPU with SSE4.1")
+set(HAVE_SSE2 0 CACHE BOOL "Have CPU with SSE2")
+set(HAVE_POWER9 0 CACHE BOOL "Have POWER9 CPU")
+set(HAVE_POWER8 0 CACHE BOOL "Have POWER8 CPU")
+set(HAVE_ARM8 0 CACHE BOOL "Have ARMv8 CPU")
+set(NATIVE_ARCH 1 CACHE BOOL "Assume native architecture for SIMD. Use one of the HAVE_* options or set CMAKE_CXX_FLAGS to the appropriate flags if you disable this.")
+
+# see https://wiki.debian.org/ArchitectureSpecificsMemo for char signedness
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -fsigned-char")
+if (CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm.*|ARM.*|aarch64.*|AARCH64.*)")
+    set(ARM 1)
+elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "PPC64*|ppc64*|powerpc64*")
+    set(PPC64 1)
+elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "amd64|AMD64")
+    set(X64 1)
+elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "x86|X86")
+    set(X86 1)
 else ()
-    include(CheckSSEFeatures)
-    ADD_DEFINITIONS(${CXX_DFLAGS})
-    if (${HAVE_AVX2_EXTENSIONS})
-        ADD_DEFINITIONS("-DAVX2")
-    elseif (${HAVE_SSE2_EXTENSIONS})
-        ADD_DEFINITIONS("-DSSE")
+    message(WARNING "CPU without native SIMD instructions. Performance will be bad.")
+endif ()
+
+# SIMD instruction sets support
+set(ARCH_FLAGS "")
+if (HAVE_AVX2)
+    if (CMAKE_COMPILER_IS_CLANG)
+        set(ARCH_FLAGS "${ARCH_FLAGS} -mavx2")
     else ()
-        message(FATAL_ERROR "At least SSE2 instruction set support is required! CMake will exit.")
-    endif (${HAVE_AVX2_EXTENSIONS})
+        set(ARCH_FLAGS "${ARCH_FLAGS} -mavx2 -Wa,-q")
+    endif ()
+elseif (HAVE_SSE4_1)
+    set(ARCH_FLAGS "${ARCH_FLAGS} -msse4.1")
+elseif (HAVE_SSE2)
+    set(ARCH_FLAGS "${ARCH_FLAGS} -msse2")
+elseif (HAVE_POWER9)
+    set(ARCH_FLAGS "${ARCH_FLAGS} -mcpu=power9 -mvsx")
+elseif (HAVE_POWER8)
+    set(ARCH_FLAGS "${ARCH_FLAGS} -mcpu=power8 -mvsx")
+elseif (HAVE_ARM8)
+    set(ARCH_FLAGS "${ARCH_FLAGS} -march=armv8-a+simd")
+endif ()
+
+if (NATIVE_ARCH AND (ARCH_FLAGS STREQUAL ""))
+    if (EMSCRIPTEN)
+        set(ARCH_FLAGS "-msimd128 -s WASM=1 -s ASSERTIONS=1")
+    elseif (X86 OR X64)
+        include(CheckSSEFeatures)
+        if (NOT HAVE_SSE4_1_EXTENSIONS)
+            if (NOT HAVE_SSE2_EXTENSIONS)
+                message(FATAL_ERROR "At least SSE2 is needed to compile")
+            endif ()
+            message(WARNING "At least SSE4.1 is needed for best performance")
+        endif ()
+        # clang has a problem with march=native on travis
+        if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.0.0")
+            set(ARCH_FLAGS "${SSE_FLAGS}")
+        else()
+            set(ARCH_FLAGS "-march=native")
+        endif()
+    else ()
+        if (PPC64)
+            set(ARCH_FLAGS "-mcpu=native")
+        else ()
+            set(ARCH_FLAGS "-march=native")
+        endif ()
+    endif ()
+endif ()
+
+if (NOT (ARCH_FLAGS STREQUAL ""))
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ARCH_FLAGS}")
+endif ()
+
+if (CMAKE_COMPILER_IS_ICC)
+    # default -fp-model results in inconsistent results in profile search
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fp-model precise")
+endif ()
+
+if (X86)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mfpmath=sse")
 endif ()
 
 find_package(OpenMP)
@@ -98,7 +159,6 @@
         hhfunc.cpp
         list.h
         log.h
-        simd.h
         )
 
 add_library(hhviterbialgorithm_with_celloff hhviterbialgorithm.cpp)
@@ -118,8 +178,8 @@
         hhviterbialgorithm_with_celloff
         hhviterbialgorithm_and_ss
         hhviterbialgorithm_with_celloff_and_ss)
-if (NOT HAVE_FMEMOPEN)
-target_link_libraries(HH_OBJECTS ext)
+if (OPENMP_FOUND AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    target_link_libraries(HH_OBJECTS ${OpenMP_CXX_LIBRARIES})
 endif()
 
 add_executable(hhblits hhblits_app.cpp)
@@ -143,6 +203,9 @@
 target_link_libraries(hhconsensus HH_OBJECTS)
 
 add_library(A3M_COMPRESS a3m_compress.cpp)
+if (OPENMP_FOUND AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    target_link_libraries(A3M_COMPRESS ${OpenMP_CXX_LIBRARIES})
+endif()
 
 add_executable(a3m_extract a3m_extract.cpp)
 target_link_libraries(a3m_extract ffindex A3M_COMPRESS)

=== lib/ffindex/src/CMakeLists.txt ===
set(CMAKE_C_FLAGS "-std=c99 ${CMAKE_C_FLAGS}")

# see https://github.com/google/sanitizers/issues/89
if (${ENABLE_SANITIZERS})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DSANITIZER_DLCLOSE")
endif ()

add_library(ffindex ffindex.c ffutil.c)
target_include_directories(ffindex PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(ext)
if (NOT HAVE_FMEMOPEN)
    target_link_libraries(ffindex ext)
endif ()

add_executable(ffindex_apply ffindex_apply_mpi.c)
target_link_libraries(ffindex_apply ffindex)
set_property(TARGET ffindex_apply PROPERTY COMPILE_FLAGS "-UHAVE_MPI")

find_package(MPI)
if (MPI_C_FOUND AND HAVE_MPI)
    add_executable(ffindex_apply_mpi ffindex_apply_mpi.c)
    target_link_libraries(ffindex_apply_mpi ffindex)
    add_subdirectory(mpq)

    set_property(TARGET ffindex_apply_mpi PROPERTY COMPILE_FLAGS "-DHAVE_MPI=1 ${MPI_C_COMPILE_FLAGS}")
    set_property(TARGET ffindex_apply_mpi PROPERTY LINK_FLAGS "${MPI_C_LINK_FLAGS}")

    target_include_directories(ffindex_apply_mpi PUBLIC ${MPI_C_INCLUDE_PATH})
    target_link_libraries(ffindex_apply_mpi mpq ${MPI_C_LIBRARIES})
    install(TARGETS ffindex_apply_mpi DESTINATION bin)
endif ()


add_executable(ffindex_reduce ffindex_reduce.c)
target_link_libraries(ffindex_reduce ffindex)

add_executable(ffindex_build ffindex_build.c)
target_link_libraries(ffindex_build ffindex)


add_executable(ffindex_from_fasta ffindex_from_fasta.c)
target_link_libraries(ffindex_from_fasta ffindex)


add_executable(ffindex_get ffindex_get.c)
target_link_libraries(ffindex_get ffindex)


add_executable(ffindex_modify ffindex_modify.c)
target_link_libraries(ffindex_modify ffindex)


add_executable(ffindex_unpack ffindex_unpack.c)
target_link_libraries(ffindex_unpack ffindex)


add_executable(ffindex_order ffindex_order.c)
target_link_libraries(ffindex_order ffindex)


add_executable(ffindex_from_fasta_with_split ffindex_from_fasta_with_split.c)
target_link_libraries(ffindex_from_fasta_with_split ffindex)


INSTALL(TARGETS ffindex_reduce
        ffindex_apply
        ffindex_build
        ffindex_from_fasta
        ffindex_get
        ffindex_modify
        ffindex_unpack
        ffindex_order
        ffindex_from_fasta_with_split
        DESTINATION bin)

=== lib/ffindex/src/ext/CMakeLists.txt ===
include(${CMAKE_ROOT}/Modules/CheckFunctionExists.cmake)
check_function_exists(fmemopen HAVE_FMEMOPEN)

if (NOT HAVE_FMEMOPEN)
    set(EXT_SRC fmemopen.c fmemopen.h)
    add_library(ext ${EXT_SRC})
endif ()

=== lib/ffindex/src/mpq/CMakeLists.txt ===
find_package(MPI)
IF(MPI_FOUND)
	set(MPQ_SRC
	  mpq.c
	  mpq.h
	)
	add_library(mpq ${MPQ_SRC})
	set_property(TARGET mpq PROPERTY COMPILE_FLAGS ${MPI_LINK_FLAGS})
	target_include_directories(mpq PUBLIC ${MPI_INCLUDE_PATH})
ENDIF()

=== debian/control ===
--- 
+++ 
@@ -5,24 +5,26 @@
            Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               libffindex0-dev (>= 0.9.9.8),
+Build-Depends: debhelper-compat (= 13),
+               libsimde-dev,
                cmake,
                imagemagick,
                help2man
-Standards-Version: 4.4.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/hhsuite
 Vcs-Git: https://salsa.debian.org/med-team/hhsuite.git
 Homepage: https://toolkit.tuebingen.mpg.de/
+Rules-Requires-Root: no
 
 Package: hhsuite
-Architecture: amd64
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${perl:Depends},
-         ffindex (>= 0.9.9.8),
          hhsuite-data (= ${source:Version}),
          python3
+Conflicts: ffindex
+Built-Using: ${simde:Built-Using}
 Description: sensitive protein sequence searching based on HMM-HMM alignment
  HH-suite is an open-source software package for sensitive protein sequence
  searching based on the pairwise alignment of hidden Markov models (HMMs).

=== debian/watch ===
version=4
opts="uversionmangle=s/-beta\.(\d)/~beta$1/;s/-beta/~beta/,repacksuffix=+ds,dversionmangle=auto,repack,compression=xz" \
https://github.com/soedinglab/hh-suite/tags .*/v(\d[-\d.beta]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
